# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    pass


def audit():
    tasks_names = [i for i in get_all_scheduled_tasks(enable_only=False)]
    enabled_tasks_names = [i for i in get_all_scheduled_tasks(enable_only=True)]
    tasks_nb = len(tasks_names)

    tasks_list = []
    enabled_tasks_list = []

    if tasks_nb == 0:
        enabled_tasks_list.append("No scheduled tasks enabled on this computer")
    else :
        for task in tasks_names:
            tasks_list.append(task)
        for task in enabled_tasks_names:
            enabled_tasks_list.append(task)

    print("Enabled scheduled tasks on this computer:")
    print('\n'.join([x for x in enabled_tasks_list]))
    WAPT.write_audit_data_if_changed('audit-scheduled-tasks', 'enabled-scheduled-tasks', ','.join([x for x in enabled_tasks_list]))
    WAPT.write_audit_data_if_changed('audit-scheduled-tasks', 'all-scheduled-tasks', ','.join([x for x in tasks_list]))

    return 'OK'




def update_package():
    pass




def get_all_scheduled_tasks(enable_only=True):
    scheduler = win32com_ensure_dispatch_patch("Schedule.Service")

    scheduler.Connect()
    objTaskFolder = scheduler.GetFolder("\\")
    colTasks = objTaskFolder.GetTasks(1)

    dict_tasks = {}

    for task in colTasks:
        if enable_only:
            if task.Enabled == False:
                continue
        dict_tasks[task.Name] = {'Name': task.Name,
                                 'Enabled': task.Enabled,
                                 'LastRunTime': task.LastRunTime,
                                 'LastTaskResult': task.LastTaskResult,
                                 'NextRunTime': task.NextRunTime,
                                 'NumberOfMissedRuns': task.NumberOfMissedRuns,
                                 'State': task.State,
                                 'Path': task.Path}

    return dict_tasks

